#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include "process.h"
#include "test.h"
#include "../../process.h"
#include "../../system.h"
#include "../../unittest.h"
#include "../../databases/job_queue/process.h"

static struct JobInfo test_jobs_info[JOB_MAX_SIZE];

static struct JobQueue test_job_queue = {
    .jobs_info = test_jobs_info
};

static struct sockaddr_in sa;

static int create_test_client();

static void unit_test_1();


void hw_stop_interface_unit_test() {
    // Set Dependent Processes
    set_process(JOB_QUEUE, &test_job_queue);
    
    unit_test_1();
}

// hw_stop 함수에 대한 테스트
static void unit_test_1() {
    struct HWStopInterface *interface = get_process(HW_STOP_INTERFACE);
    struct JobQueue *jq = get_process(JOB_QUEUE);
    
    char test_buf[1];
    test_buf[0] = 1;
    int csock = create_test_client();
    if ( csock < 0 ) { unit_test_assert("NPS UTC 2000_003 HW_STOP_INTERFACE - unit_test_1", 0); return; }

    sendto(csock, test_buf, 1, 0, (struct sockaddr *)&sa, sizeof(sa));
    
    unit_test_assert("NPS UTC 2000_003 HW_STOP_INTERFACE - unit_test_1", interface->hw_stop());
}


static int create_test_client() {
    int sock;
    
    if ( (sock = socket(AF_INET, SOCK_DGRAM, 0)) < 0 ) return -1;
    
    sa.sin_family = AF_INET;
    sa.sin_addr.s_addr = inet_addr("127.0.0.1");
    sa.sin_port = htons(6600);
    
    return sock;
}