#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "process.h"
#include "test.h"
#include "../../process.h"
#include "../../system.h"
#include "../../unittest.h"


static void print(char *message);

struct LCDInterface lcd_interface = {
    .print=print
};

static void init_socket();

static int client;
static struct sockaddr_in serveraddr;

void init_lcd_interface() {
    printf("Initialization LCD Interface...\t\t");
    set_process(LCD_INTERFACE, &lcd_interface);
    SET_UNIT_TEST(LCD_INTERFACE, lcd_interface_unit_test);
    init_socket();
    printf("\033[92m[OK]\033[0m\n");
}

static void print(char *message) {
    sendto(client, message, strlen(message), 0, (struct sockaddr *)&serveraddr, sizeof(serveraddr));
}

static void init_socket() {
    client = socket(AF_INET, SOCK_DGRAM, 0);
    if (socket < 0)
    {
        perror("LCD Interface Socket Error!");
        exit(0);
    }
    
    bzero(&serveraddr, sizeof(serveraddr));
    serveraddr.sin_family = AF_INET;
    serveraddr.sin_addr.s_addr = inet_addr("127.0.0.1");
    serveraddr.sin_port = htons(6700);
}
