#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "../../process.h"
#include "../../unittest.h"
#include "process.h"
#include "test.h"

static void unit_test_1();

static int create_test_client();


void network_rx_interface_unit_test() {
    // 테스트
    unit_test_1();
}


static void unit_test_1() {
    char test_packet[] = {0, 0, 0, 0, 3, 'a', 'b', 'c'};
    
    int i;
    int test_client;
    struct Packet packet;
    packet.data = NULL;
    
    struct NetworkRxInterface *process = get_process(NETWORK_RX_INTERFACE);
    
    test_client = create_test_client();

    send(test_client, test_packet, 8, 0);
    
    while(packet.data == NULL) packet = process->get_rx_packet();
    unit_test_assert("NETWORK_RX_INTERFACE - unit_test_1", packet.data[0] == 'a' && packet.data[1] == 'b' && packet.data[2] == 'c');
}




static int create_test_client() {
    int sock;
    struct sockaddr_in server;
    
    sock = socket(AF_INET, SOCK_STREAM, 0);
    if(sock < 0) return -1;
    
    server.sin_addr.s_addr = inet_addr("127.0.0.1");
    server.sin_family = AF_INET;
    server.sin_port = htons(6000);
    
    if (connect(sock, (struct sockaddr *)&server , sizeof(server)) < 0) return -1;
    
    return sock;
}
