#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "process.h"
#include "test.h"
#include "../../process.h"
#include "../../system.h"
#include "../../unittest.h"
#include "../network_rx_interface/process.h"

static void send_packet(struct Packet);

static struct NetworkTxInterface network_tx_interface = {
    .send_packet = send_packet
};

void init_network_tx_interface() {
    set_process(NETWORK_TX_INTERFACE, &network_tx_interface);
    SET_UNIT_TEST(NETWORK_TX_INTERFACE, network_tx_interface_unit_test);
}


static void send_packet(struct Packet packet)
{
    char *message;
    int len = 1 + 4 + packet.length;
    message = malloc(sizeof(char) * len);
    
    memcpy(message + 1 + 4, packet.data, packet.length);
    
    message[0] = 0;
    message[1] = (packet.length >> 24) & 0xff;
    message[2] = (packet.length >> 16) & 0xff;
    message[3] = (packet.length >> 8) & 0xff;
    message[4] = packet.length & 0xff;
    
    int i;
    if(packet.sock != -1) {
        write(packet.sock, message, len);
    } else {
         for(i=0; i<64; i++) {
             if(_sock_list[i] != 0) {
                write(_sock_list[i], message, len);
            }
         }
    }
    
    free(message);
}
