#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "process.h"
#include "test.h"
#include "../../process.h"
#include "../../system.h"
#include "../../unittest.h"

static void unit_test_1();
static int create_test_client();

void network_tx_interface_unit_test() {
    unit_test_1();
}

static void unit_test_1() {
    struct NetworkTxInterface *interface = get_process(NETWORK_TX_INTERFACE);
    struct Packet p;
    char data[1];
    char buf[6];
    
    memset(buf, 0, 6);
    
    int fp = fopen("output/tx.dat", "wb+");

    p.length = 1;
    p.data = data;
    p.sock = fileno(fp);

    data[0] = 127;
    interface->send_packet(p);
    
    fseek(fp, 0, SEEK_SET);
    fread(buf, 1, 6, fp);
    
    unit_test_assert("NETWORK_TX_INTERFACE - unit_test_1",
        buf[0] == 0 &&
        buf[1] == 0 &&
        buf[2] == 0 &&
        buf[3] == 0 &&
        buf[4] == 1 &&
        buf[5] == 127
    );
}
