#include <stdio.h>
#include <string.h>
#include <time.h>
#include "../../process.h"
#include "../../unittest.h"
#include "process.h"
#include "test.h"
#include "../../databases/user_database/process.h"
#include "../../databases/job_queue/process.h"


static void trigger();

// 프로세스 정의
struct SavePrintResult save_print_result = {
    .trigger = trigger
};


void init_save_print_result() {
    printf("Initialization Save Print Result ...\t\t");
    set_process(SAVE_PRINT_RESULT, &save_print_result);
	SET_UNIT_TEST(SAVE_PRINT_RESULT, save_print_result_unit_test);
	printf("\033[92m[OK]\033[0m\n");
}

static void trigger() {
    struct JobQueue *queue = get_process(JOB_QUEUE);
    
    if(queue->jobs_info[0].fd == -1) {
        char file_name[255];
        time_t timer;
        struct tm *t;
        
        timer = time(NULL);
        t = localtime(&timer);
        
        sprintf(file_name, "output/%d%02d%02d%02d%02d%02d.txt", t->tm_year + 1900, t->tm_mon + 1, t->tm_mday, t->tm_hour, t->tm_min, t->tm_sec);
        queue->jobs_info[0].fd = fopen(file_name, "w");
    }
    
    int i;
    int line_count = 0;
    int require_ink = 0;
    int line_text_length = 0;
    
    if(queue->jobs_info[0].current_page != 0) {
        fputc('\n', queue->jobs_info[0].fd);
        fputc('\n', queue->jobs_info[0].fd);
    }
    
    for(i=0; i<queue->jobs_info[0].file_size && line_count/10 <= queue->jobs_info[0].current_page; i++) {
        if(line_count/10 == queue->jobs_info[0].current_page && (line_text_length < 30 | queue->jobs_info[0].buffer[i] == '\n'))
            fputc(queue->jobs_info[0].buffer[i], queue->jobs_info[0].fd);
        
        if(queue->jobs_info[0].buffer[i] != '\n') {
            if(line_count/10 == queue->jobs_info[0].current_page && line_text_length < 30) {
                line_text_length += 1;
            }
        } else {
            line_count++;
            line_text_length = 0;
        }
    }
}
