#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../../process.h"
#include "../../unittest.h"
#include "process.h"
#include "test.h"
#include "../../databases/job_queue/process.h"

static struct JobInfo test_jobs_info[JOB_MAX_SIZE];

static struct JobQueue test_job_queue = {
    .jobs_info = test_jobs_info
};

static void init_job() {
    test_jobs_info[0].fd = fopen("output/test.txt", "w+");
    test_jobs_info[0].job_id = 1;
    
    memset(test_jobs_info[0].user_id, 0, 12);
    sprintf(test_jobs_info[0].user_id, "admin");
    
    test_jobs_info[0].current_page = 0;
    test_jobs_info[0].total_page = 5;
    test_jobs_info[0].state = 0;
}

static int print_test(char *input, char *output, int page) {
    int size;
    struct SavePrintResult *process = get_process(SAVE_PRINT_RESULT);
    init_job();
    test_jobs_info[0].current_page = page;
    test_jobs_info[0].file_size = strlen(input);
    test_jobs_info[0].buffer = input;
    
    process->trigger();
    
    int fp = test_jobs_info[0].fd;
    fseek(fp, 0, SEEK_END); 
    size = ftell(fp);
    fseek(fp, 0, SEEK_SET);
    
    char *buf = malloc((size+1)*sizeof(char));
    
    fread(buf, 1, size, fp);
    buf[size] = 0;
    
    int result = !strcmp(output, buf);
    
    free(buf);
    return result;
}


void save_print_result_unit_test() {
    // 의존성 있는 프로세스 정의 (프로세스에서 호출하는 것들)
    set_process(JOB_QUEUE, &test_job_queue);

    unit_test_assert("NPS UTC 5000_009 SAVE_PRINT_RESULT - unit_test_1",
        print_test("test", "test", 0)
    );
    // 가로 30 자 테스트
    unit_test_assert("NPS UTC 5000_010 SAVE_PRINT_RESULT - unit_test_2",
        print_test("testtesttesttesttesttesttesttest", "testtesttesttesttesttesttestte", 0)
    );
    // 한장 10줄 테스트
    unit_test_assert("NPS UTC 5000_011 SAVE_PRINT_RESULT - unit_test_3",
        print_test("a\na\na\na\na\na\na\na\na\na\na\na\n", "a\na\na\na\na\na\na\na\na\na\n", 0)
    );
}