#include <stdio.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include "../../process.h"
#include "../../unittest.h"
#include "process.h"
#include "test.h"
#include "../../databases/ink_paper_state_database/process.h"


static void unit_test_1();

static int create_test_client();


void virtual_refill_interface_unit_test() {
    // 테스트
    unit_test_1();
}



static void unit_test_1() {
    struct VirtualRefillInterface *interface = get_process(VIRTUAL_REFILL_INTERFACE);
    struct RequestRefillInfo info;
    int client;
    
    char test_buf[] = {0,0,0,0,10};
    
    struct sockaddr_in server;
    bzero(&server, sizeof(server));
    server.sin_addr.s_addr = inet_addr("127.0.0.1");
    server.sin_family = AF_INET;
    server.sin_port = htons(6500);
    
    client = create_test_client();
    
    sendto(client, test_buf, 8, 0, (struct sockaddr *)&server, sizeof(server));
    
    info = interface->get_request_info();
    
    unit_test_assert(
        "NPS UTC 1000_124 VIRTUAL_REFILL_INTERFACE - unit_test_1",
        info.type == 0 && info.value == 10
    );
}


static int create_test_client() {
    int sock;
    
    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) return -1;
    
    
    return sock;
}