#include "unittest.h"
#include "system.h"
#include "processes/processes.h"
#include "databases/databases.h"
#include "interfaces/interfaces.h"

int main()
{
	init_auth_and_dispatch_controller();
	init_request_to_cancel_printing_process();
	init_fail_auth_dispatcher();
	init_print_validation_process();
	
	init_user_creation_process();
	init_user_listing_process();
	init_user_removal_process();
	
	init_hw_stop_interface();
	init_hw_stop_controller();
	init_hw_stop_process();
	
	init_reset_wait_refill_ink_process();
	init_reset_wait_refill_paper_process();
	init_wait_refill_ink_addition_process();
	init_wait_refill_paper_addition_process();
	init_refill_ink_process();
	init_refill_paper_process();
	init_virtual_refill_controller();
	init_virtual_refill_interface();
	
	init_printing_controller();
	init_job_queue_pop();
	init_next_page();
	init_decrease_amount_of_ink_paper();
	init_save_print_result();
	
	init_send_status_process();
	init_lcd_interface();
	init_view_controller();
	
	init_ink_paper_state_database();
	init_user_database();
	init_job_queue();
	init_network_rx_interface();
	
	init_network_tx_interface();
	// Add Process

#ifdef UNIT_TEST
	run_unit_test();
#else
	run_system();
#endif
	return 0;
}