#include "../../../../process.h"
#include "../../../../unittest.h"
#include "process.h"
#include "test.h"
#include "../../../../interfaces/network_rx_interface/process.h"
#include "../../../../interfaces/network_tx_interface/process.h"

static void trigger();

// 프로세스 정의
const struct FailAuthDispatcher fail_auth_dispatcher = {
    .trigger = trigger
};


void init_fail_auth_dispatcher() {
    printf("Initialization Fail Auth Dispatcher...\t\t");
    set_process(FAIL_AUTH_DISPATCHER, &fail_auth_dispatcher);
	SET_UNIT_TEST(FAIL_AUTH_DISPATCHER, fail_auth_dispatcher_unit_test);
    printf("\033[92m[OK]\033[0m\n");
}

static void trigger(struct Packet *packet) {
    struct Packet res;
    char res_data[TYPE_LENGTH + REQ_ID_LENGTH + RES_TYPE_LENGTH];
    
    memcpy(res_data, packet->data, TYPE_LENGTH + REQ_ID_LENGTH);
    
    res_data[TYPE_LENGTH + REQ_ID_LENGTH] = -1; // set res_type
    
    
    res.data = res_data;
    res.length = TYPE_LENGTH + REQ_ID_LENGTH + RES_TYPE_LENGTH;
    res.sock = packet->sock;

    ((struct NetworkTxInterface *)get_process(NETWORK_TX_INTERFACE))->send_packet(res);
}
