#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../../../../process.h"
#include "../../../../unittest.h"
#include "process.h"
#include "test.h"
#include "../../../../databases/user_database/process.h"
#include "../../../../interfaces/network_tx_interface/process.h"

static char *trigger();

// 프로세스 정의
static struct UserListingProcess user_listing_process = {
    .trigger = trigger
};

void init_user_listing_process() {
    printf("Initialization User Listing Process...\t\t");
    set_process(USER_LISTING_PROCESS, &user_listing_process);
	SET_UNIT_TEST(USER_LISTING_PROCESS, user_listing_process_unit_test);
	printf("\033[92m[OK]\033[0m\n");
}

static char *trigger(struct Packet *packet) {
    struct UserDatabase *user_db = get_process(USER_DATABASE);
    int user_count = 0;
    
    struct UserInfo *user;
    
    for(user=user_db->header->nextInfo; user!=user_db->tailer; user=user->nextInfo) {
        user_count++;
    }
    
    char *res = malloc(TYPE_LENGTH + REQ_ID_LENGTH + 1 + 4 + (sizeof(char) * USER_ID_MAX_LENGTH + 1) * user_count);
    memcpy(res, packet->data, TYPE_LENGTH + REQ_ID_LENGTH);
    int start = TYPE_LENGTH + REQ_ID_LENGTH;
    res[start] = 0;
    res[start+1] = (user_count >> 24) & 0xff;
    res[start+2] = (user_count >> 16) & 0xff;
    res[start+3] = (user_count >> 8) & 0xff;
    res[start+4] = user_count & 0xff;    
    
    start += 5;
    for(user=user_db->header->nextInfo; user!=user_db->tailer; user=user->nextInfo) {
        memcpy(res+start, user->user_id, USER_ID_MAX_LENGTH);
        res[start+USER_ID_MAX_LENGTH] = user->is_admin;
        start += USER_ID_MAX_LENGTH + 1;
    }
    
    struct Packet res_packet;
    res_packet.data = res;
    res_packet.length = start;
    res_packet.sock = packet->sock;
    
    ((struct NetworkTxInterface *)get_process(NETWORK_TX_INTERFACE))->send_packet(res_packet);
    
    free(res);
}
