#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../../../../process.h"
#include "../../../../unittest.h"
#include "process.h"
#include "test.h"
#include "../../../../databases/user_database/process.h"
#include "../../../../interfaces/network_tx_interface/process.h"

static int a = 0;

static struct UserInfo v_header;
static struct UserInfo v_tailer;

static void test_send_packet();

static struct UserDatabase test_user_database = {
    .header = &v_header,
    .tailer = &v_tailer
};


static struct NetworkTxInterface test_tx_interface = {
    .send_packet = test_send_packet
};


static void unit_test_1();


void user_listing_process_unit_test() {
    struct UserInfo *tmp_usr[10];       // 유저는 10명 생성한다.
    struct UserInfo *tmp_lnk;           // 연결 생성용 임시 유저 노드
    char buf[12];
    int i;
    // 의존성 있는 프로세스 정의 (프로세스에서 호출하는 것들)
    set_process(USER_DATABASE, &test_user_database);
    set_process(NETWORK_TX_INTERFACE, &test_tx_interface);
    
    
    // 리스트 초기화
     v_header.nextInfo = &v_tailer;
     v_tailer.prevInfo = &v_header;
     
    // 테스트 유저 추가
    for ( i = 0 ; i < 10 ; i++ ) {
        // 구조체 초기화 (공간 할당)
        tmp_usr[i] = (struct UserInfo *)malloc(sizeof(struct UserInfo));
        memset(tmp_usr[i], 0, sizeof(struct UserInfo));
        // ID 입력
        memset(buf, 0, 12);
        sprintf(buf, "user%d", i);
        strcpy(tmp_usr[i]->user_id, buf);
        // PW 입력
        memset(buf, 0, 12);
        sprintf(buf, "pass%d", i);
        strcpy(tmp_usr[i]->user_pw, buf);
        
        // 연결 생성
        tmp_lnk = test_user_database.tailer->prevInfo; 
        
        tmp_lnk->nextInfo = tmp_usr[i];
        tmp_usr[i]->prevInfo = tmp_lnk;
        tmp_usr[i]->nextInfo = test_user_database.tailer;
        test_user_database.tailer->prevInfo = tmp_usr[i];
    }
     
    // 테스트
    unit_test_1();
    
    for(i = 0; i < 10; i++){
        free(tmp_usr[i]);
    }
    
    v_header.nextInfo = &v_tailer;
    v_tailer.prevInfo = &v_header;
}

static void unit_test_1() {
    struct UserListingProcess *process = get_process(USER_LISTING_PROCESS);
    
    struct Packet test_user_packet = {
       .data = "\0\0\0\0\0",
       .length = TYPE_LENGTH + REQ_ID_LENGTH,
       .sock = 0
    };
    
    process->trigger(&test_user_packet);
    
    
    unit_test_assert("NPS UTC 3000_023 USER_LISTING_PROCESS - unit_test_1", a);
}



void test_send_packet(struct Packet packet){
    struct UserDatabase *db = get_process(USER_DATABASE);
    int start = TYPE_LENGTH + REQ_ID_LENGTH + 5;
    struct UserInfo * user;
    char * res = malloc(sizeof(packet));
    res = packet.data;
    a = 1;
    
    for(user=db->header->nextInfo; user!=db->tailer; user=user->nextInfo) {
        a = a && !memcmp(user->user_id, res+start, USER_ID_MAX_LENGTH);
        a = a && (user->is_admin == res[start+USER_ID_MAX_LENGTH]);
        start += USER_ID_MAX_LENGTH + 1;
    }
}