#include "process.h"
#include "test.h"
#include "../../../../process.h"
#include "../../../../system.h"
#include "../../../../unittest.h"
#include "../../../../databases/job_queue/process.h"

static struct JobInfo test_jobs_info = {

};

static struct JobQueue test_job_queue = {
    .jobs_info = &test_jobs_info
};

static void unit_test_1();
static void unit_test_2();
static void unit_test_3();

void hw_stop_process_unit_test() {
    set_process(JOB_QUEUE, &test_job_queue);
    
    unit_test_1();
    unit_test_2();
    unit_test_3();
}

// 현재 JobQueue가 비어있는 경우
static void unit_test_1() {
    struct HWStopProcess *process = get_process(HW_STOP_PROCESS);
    
    test_jobs_info.job_id = -1;
    test_jobs_info.state = 0;
    process->trigger();
    unit_test_assert("NPS UTC 2000_000 HW_STOP_PROCESS - unit_test_1", test_jobs_info.state == 0);
}

// 현재 인쇄중이거나 대기중인 경우
static void unit_test_2() {
    struct HWStopProcess *process = get_process(HW_STOP_PROCESS);
    
    test_jobs_info.job_id = 1;
    test_jobs_info.state = 0;
    process->trigger();
    unit_test_assert("NPS UTC 2000_001 HW_STOP_PROCESS - unit_test_2", test_jobs_info.state == 1);
}

// 현재 삭제중인 경우
static void unit_test_3() {
    struct HWStopProcess *process = get_process(HW_STOP_PROCESS);
    
    
    test_jobs_info.job_id = 1;
    test_jobs_info.state = 1;
    process->trigger();
    unit_test_assert("NPS UTC 2000_002 HW_STOP_PROCESS - unit_test_3", test_jobs_info.state == 1);
}