#include "../../../../process.h"
#include "../../../../unittest.h"
#include "process.h"
#include "test.h"
#include "../../../../databases/ink_paper_state_database/process.h"


static void trigger();

// 프로세스 정의
static struct RefillPaperProcess refill_paper_process = {
    .trigger = trigger
};


void init_refill_paper_process() {
    printf("Initialization Refill Paper Process...\t\t");
    set_process(REFILL_PAPER_PROCESS, &refill_paper_process);
	SET_UNIT_TEST(REFILL_PAPER_PROCESS, refill_paper_process_unit_test);
	printf("\033[92m[OK]\033[0m\n");
}

static void trigger() {
    struct InkPaperStateDatabase *db = get_process(INK_PAPER_STATE_DATABASE);
    
    if(*(db->wait_refill_paper_value) < 0) return;

    int value = *(db->wait_refill_paper_value) < 10 ? *(db->wait_refill_paper_value) : 10;
    
    *(db->current_paper_value) += value;
    *(db->wait_refill_paper_value) -= value;
    
    if(*(db->current_paper_value) > PAPER_MAX_VALUE)
        *(db->current_paper_value) = PAPER_MAX_VALUE;
}