#include <stdio.h>
#include "../../../../process.h"
#include "../../../../unittest.h"
#include "process.h"
#include "test.h"
#include "../../../../databases/ink_paper_state_database/process.h"

static int test_ink_value = 0;
static int test_wait_refill_ink_value = 0;
static int test_paper_value = 0;
static int test_wait_refill_paper_value = 0;

static struct InkPaperStateDatabase test_ink_paper_state_database = {
    .current_ink_value = &test_ink_value,
    .wait_refill_ink_value = &test_wait_refill_ink_value,
    .current_paper_value = &test_paper_value,
    .wait_refill_paper_value = &test_wait_refill_paper_value
};

static void unit_test_1();
static void unit_test_2();


void reset_wait_refill_ink_process_unit_test() {
    // 의존성 있는 프로세스 정의 (프로세스에서 호출하는 것들)
    set_process(INK_PAPER_STATE_DATABASE, &test_ink_paper_state_database);
    
    // 테스트
    unit_test_1();
    unit_test_2();
}



//기본 값 체크
static void unit_test_1() {
    struct ResetWaitRefillInkProcess *process = get_process(RESET_WAIT_REFILL_INK_PROCESS);
    
    test_wait_refill_ink_value = 100;
    process->trigger();
    unit_test_assert("NPS UTC 1000_090 RESET_WAIT_REFILL_INK_PROCESS - unit_test_1", test_wait_refill_ink_value == 0);
}

//0 값 체크
static void unit_test_2() {
    struct ResetWaitRefillInkProcess *process = get_process(RESET_WAIT_REFILL_INK_PROCESS);
    
    test_wait_refill_ink_value = 0;
    process->trigger();
    unit_test_assert("NPS UTC 1000_091 RESET_WAIT_REFILL_INK_PROCESS - unit_test_2", test_wait_refill_ink_value == 0);
}