#include "../../../../process.h"
#include "../../../../unittest.h"
#include "process.h"
#include "test.h"
#include "../../../../databases/ink_paper_state_database/process.h"


static void trigger(int);

// 프로세스 정의
static struct WaitRefillInkAdditionProcess wait_refill_ink_addition_process = {
    .trigger = trigger
};


void init_wait_refill_ink_addition_process() {
    printf("Initialization Wait Refill Ink Addition Process...\t\t");
    set_process(WAIT_REFILL_INK_ADDITION_PROCESS, &wait_refill_ink_addition_process);
	SET_UNIT_TEST(WAIT_REFILL_INK_ADDITION_PROCESS, wait_refill_ink_addition_process_unit_test);
    printf("\033[92m[OK]\033[0m\n");
}

static void trigger(int value) {
    struct InkPaperStateDatabase *db = get_process(INK_PAPER_STATE_DATABASE);
    
    if(*(db->wait_refill_ink_value) + *(db->current_ink_value) > INK_MAX_VALUE) {
        *(db->wait_refill_ink_value) = INK_MAX_VALUE - *(db->current_ink_value);
    }
    
    if(value < 0) return;

    *(db->wait_refill_ink_value) += value;
    
    // TODO : 문서 변경해야함!!!!
    if(*(db->wait_refill_ink_value) + *(db->current_ink_value) > INK_MAX_VALUE) {
        *(db->wait_refill_ink_value) = INK_MAX_VALUE - *(db->current_ink_value);
    }
}
