#include <stdio.h>
#include "../../../../process.h"
#include "../../../../unittest.h"
#include "process.h"
#include "test.h"
#include "../../../../databases/ink_paper_state_database/process.h"

static int test_ink_value = 0;
static int test_wait_refill_ink_value = 0;
static int test_paper_value = 0;
static int test_wait_refill_paper_value = 0;

static struct InkPaperStateDatabase test_ink_paper_state_database = {
    .current_ink_value = &test_ink_value,
    .wait_refill_ink_value = &test_wait_refill_ink_value,
    .current_paper_value = &test_paper_value,
    .wait_refill_paper_value = &test_wait_refill_paper_value
};

static void unit_test_1();
static void unit_test_2();
static void unit_test_3();
static void unit_test_4();
static void unit_test_5();
static void unit_test_6();
static void unit_test_7();
static void unit_test_8();
static void unit_test_9();
static void unit_test_10();
static void unit_test_11();
static void unit_test_12();
static void unit_test_13();
static void unit_test_14();
static void unit_test_15();
static void unit_test_16();
static void unit_test_17();
static void unit_test_18();
static void unit_test_19();
static void unit_test_20();
static void unit_test_21();
static void unit_test_22();
static void unit_test_23();
static void unit_test_24();
static void unit_test_25();
static void unit_test_26();
static void unit_test_27();
static void unit_test_28();
static void unit_test_29();
static void unit_test_30();
static void unit_test_31();
static void unit_test_32();
static void unit_test_33();
static void unit_test_34();
static void unit_test_35();
static void unit_test_36();
static void unit_test_37();
static void unit_test_38();
static void unit_test_39();
static void unit_test_40();
static void unit_test_41();
static void unit_test_42();
static void unit_test_43();
static void unit_test_44();
static void unit_test_45();


void wait_refill_ink_addition_process_unit_test() {
    // 의존성 있는 프로세스 정의 (프로세스에서 호출하는 것들)
    set_process(INK_PAPER_STATE_DATABASE, &test_ink_paper_state_database);
    
    
    // 테스트
    test_ink_value = 0;
    unit_test_1();
    unit_test_2();
    unit_test_3();
    unit_test_4();
    unit_test_5();
    unit_test_6();
    unit_test_7();
    unit_test_8();
    unit_test_9();
    unit_test_10();
    unit_test_11();
    unit_test_12();
    unit_test_13();
    unit_test_14();
    unit_test_15();
    
    test_ink_value = INK_MAX_VALUE / 2;
    unit_test_16();
    unit_test_17();
    unit_test_18();
    unit_test_19();
    unit_test_20();
    unit_test_21();
    unit_test_22();
    unit_test_23();
    unit_test_24();
    unit_test_25();
    unit_test_26();
    unit_test_27();
    unit_test_28();
    unit_test_29();
    unit_test_30();
    
    
    test_ink_value = INK_MAX_VALUE;
    unit_test_31();
    unit_test_32();
    unit_test_33();
    unit_test_34();
    unit_test_35();
    unit_test_36();
    unit_test_37();
    unit_test_38();
    unit_test_39();
    unit_test_40();
    unit_test_41();
    unit_test_42();
    unit_test_43();
    unit_test_44();
    unit_test_45();
    
}



// 1~5 : ink_value = 0, wait_refill_ink_value = 0
//0 체크
static void unit_test_1() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = 0;
    process->trigger(0);
    unit_test_assert("NPS UTC 1000_000 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_1", test_wait_refill_ink_value == 0);
}

//음수 체크
static void unit_test_2() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = 0;
    process->trigger(-10);
    unit_test_assert("NPS UTC 1000_001 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_2", test_wait_refill_ink_value == 0);
}

//맥스값 체크
static void unit_test_3() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = 0;
    process->trigger(INK_MAX_VALUE);
    unit_test_assert("NPS UTC 1000_002 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_3", test_wait_refill_ink_value == INK_MAX_VALUE);
}

//오버값 체크
static void unit_test_4() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = 0;
    process->trigger(5000);
    unit_test_assert("NPS UTC 1000_003 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_4", test_wait_refill_ink_value == (INK_MAX_VALUE - test_ink_value));
}


//기본값 체크
static void unit_test_5() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = 0;
    process->trigger(10);
    unit_test_assert("NPS UTC 1000_004 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_5", test_wait_refill_ink_value == 10);
}



//6~10 : ink_value = 0, wait_refill_ink_value = INK_MAX_VALUE / 2
//0 체크
static void unit_test_6() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = INK_MAX_VALUE / 2;
    process->trigger(0);
    unit_test_assert("NPS UTC 1000_005 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_6", test_wait_refill_ink_value == INK_MAX_VALUE / 2 );
}

//음수 체크
static void unit_test_7() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = INK_MAX_VALUE / 2;
    process->trigger(-10);
    unit_test_assert("NPS UTC 1000_006 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_7", test_wait_refill_ink_value == INK_MAX_VALUE / 2 );
}

//맥스값 체크
static void unit_test_8() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = INK_MAX_VALUE / 2;
    process->trigger(INK_MAX_VALUE);
    unit_test_assert("NPS UTC 1000_007 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_8", test_wait_refill_ink_value == INK_MAX_VALUE);
}

//오버값 체크
static void unit_test_9() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = INK_MAX_VALUE / 2;
    process->trigger(5000);
    unit_test_assert("NPS UTC 1000_008 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_9", test_wait_refill_ink_value == (INK_MAX_VALUE - test_ink_value));
}


//기본값 체크
static void unit_test_10() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = INK_MAX_VALUE / 2;
    process->trigger(10);
    unit_test_assert("NPS UTC 1000_009 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_10", test_wait_refill_ink_value == (INK_MAX_VALUE / 2 + 10));
}


//11 ~ 15 : ink_value = 0, wait_refill_ink_value = INK_MAX_VALUE
//0 체크
static void unit_test_11() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);
    
    test_wait_refill_ink_value = INK_MAX_VALUE;
    process->trigger(0);
    unit_test_assert("NPS UTC 1000_010 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_11", test_wait_refill_ink_value == INK_MAX_VALUE);
}

//음수 체크
static void unit_test_12() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);
    
    test_wait_refill_ink_value = INK_MAX_VALUE;
    process->trigger(-10);
    unit_test_assert("NPS UTC 1000_011 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_12", test_wait_refill_ink_value == INK_MAX_VALUE);
}

//맥스값 체크
static void unit_test_13() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);
    
    test_wait_refill_ink_value = INK_MAX_VALUE;
    process->trigger(INK_MAX_VALUE);
    unit_test_assert("NPS UTC 1000_012 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_13", test_wait_refill_ink_value == INK_MAX_VALUE);
}

//오버값 체크
static void unit_test_14() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);
    
    test_wait_refill_ink_value = INK_MAX_VALUE;
    process->trigger(5000);
    unit_test_assert("NPS UTC 1000_013 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_14", test_wait_refill_ink_value == INK_MAX_VALUE);
}

//기본값 체크
static void unit_test_15() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);
    
    test_wait_refill_ink_value = INK_MAX_VALUE;
    process->trigger(10);
    unit_test_assert("NPS UTC 1000_014 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_15", test_wait_refill_ink_value == INK_MAX_VALUE);
}

// 16~20 : ink_value = INK_MAX_VALUE / 2, wait_refill_ink_value = 0
//0 체크
static void unit_test_16() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = 0;
    process->trigger(0);
    unit_test_assert("NPS UTC 1000_015 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_16", test_wait_refill_ink_value == 0);
}

//음수 체크
static void unit_test_17() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = 0;
    process->trigger(-10);
    unit_test_assert("NPS UTC 1000_016 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_17", test_wait_refill_ink_value == 0);
}

//맥스값 체크
static void unit_test_18() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = 0;
    process->trigger(INK_MAX_VALUE);
    unit_test_assert("NPS UTC 1000_017 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_18", test_wait_refill_ink_value == (INK_MAX_VALUE - test_ink_value));
}

//오버값 체크
static void unit_test_19() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = 0;
    process->trigger(5000);
    unit_test_assert("NPS UTC 1000_018 NPS UTC 1000_018 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_19", test_wait_refill_ink_value == (INK_MAX_VALUE - test_ink_value));
}


//기본값 체크
static void unit_test_20() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = 0;
    process->trigger(10);
    unit_test_assert("NPS UTC 1000_019 NPS UTC 1000_019 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_20", test_wait_refill_ink_value == 10);
}



//21~25 : ink_value = INK_MAX_VALUE / 2, wait_refill_ink_value = INK_MAX_VALUE / 2
//0 체크
static void unit_test_21() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = INK_MAX_VALUE / 2;
    process->trigger(0);
    unit_test_assert("NPS UTC 1000_020 NPS UTC 1000_020 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_21", test_wait_refill_ink_value == INK_MAX_VALUE / 2);
}

//음수 체크
static void unit_test_22() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = INK_MAX_VALUE / 2;
    process->trigger(-10);
    unit_test_assert("NPS UTC 1000_021 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_22", test_wait_refill_ink_value == INK_MAX_VALUE / 2);
}

//맥스값 체크
static void unit_test_23() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = INK_MAX_VALUE / 2;
    process->trigger(INK_MAX_VALUE);
    unit_test_assert("NPS UTC 1000_022 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_23", test_wait_refill_ink_value == (INK_MAX_VALUE - test_ink_value));
}

//오버값 체크
static void unit_test_24() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = INK_MAX_VALUE / 2;
    process->trigger(5000);
    unit_test_assert("NPS UTC 1000_023 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_24", test_wait_refill_ink_value == (INK_MAX_VALUE - test_ink_value));
}


//기본값 체크
static void unit_test_25() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = INK_MAX_VALUE / 2;
    process->trigger(10);
    unit_test_assert("NPS UTC 1000_024 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_25", test_wait_refill_ink_value == (INK_MAX_VALUE - test_ink_value));
}


//26 ~ 30 : ink_value = INK_MAX_VALUE / 2, wait_refill_ink_value = INK_MAX_VALUE
//0 체크
static void unit_test_26() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);
    
    test_wait_refill_ink_value = INK_MAX_VALUE;
    process->trigger(0);
    unit_test_assert("NPS UTC 1000_025 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_26",  test_wait_refill_ink_value == (INK_MAX_VALUE - test_ink_value));
}

//음수 체크
static void unit_test_27() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);
    
    test_wait_refill_ink_value = INK_MAX_VALUE;
    process->trigger(-10);
    unit_test_assert("NPS UTC 1000_026 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_27",  test_wait_refill_ink_value == (INK_MAX_VALUE - test_ink_value));
}

//맥스값 체크
static void unit_test_28() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);
    
    test_wait_refill_ink_value = INK_MAX_VALUE;
    process->trigger(INK_MAX_VALUE);
    unit_test_assert("NPS UTC 1000_027 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_28",  test_wait_refill_ink_value == (INK_MAX_VALUE - test_ink_value));
}

//오버값 체크
static void unit_test_29() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);
    
    test_wait_refill_ink_value = INK_MAX_VALUE;
    process->trigger(5000);
    unit_test_assert("NPS UTC 1000_028 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_29",  test_wait_refill_ink_value == (INK_MAX_VALUE - test_ink_value));
}

//기본값 체크
static void unit_test_30() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);
    
    test_wait_refill_ink_value = INK_MAX_VALUE;
    process->trigger(10);
    unit_test_assert("NPS UTC 1000_029 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_30",  test_wait_refill_ink_value == (INK_MAX_VALUE - test_ink_value));
}



// 31~35 : ink_value = INK_MAX_VALUE, wait_refill_ink_value = 0
//0 체크
static void unit_test_31() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = 0;
    process->trigger(0);
    unit_test_assert("NPS UTC 1000_030 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_31", test_wait_refill_ink_value == 0);
}

//음수 체크
static void unit_test_32() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = 0;
    process->trigger(-10);
    unit_test_assert("NPS UTC 1000_031 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_32", test_wait_refill_ink_value == 0);
}

//맥스값 체크
static void unit_test_33() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = 0;
    process->trigger(INK_MAX_VALUE);
    unit_test_assert("NPS UTC 1000_032 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_33", test_wait_refill_ink_value == 0);
}

//오버값 체크
static void unit_test_34() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = 0;
    process->trigger(5000);
    unit_test_assert("NPS UTC 1000_033 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_34", test_wait_refill_ink_value == 0);
}


//기본값 체크
static void unit_test_35() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = 0;
    process->trigger(10);
    unit_test_assert("NPS UTC 1000_034 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_35", test_wait_refill_ink_value == 0);
}



//36~40 : ink_value = INK_MAX_VALUE, wait_refill_ink_value = INK_MAX_VALUE / 2
//0 체크
static void unit_test_36() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = INK_MAX_VALUE / 2;
    process->trigger(0);
    unit_test_assert("NPS UTC 1000_035 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_36", test_wait_refill_ink_value == 0);
}

//음수 체크
static void unit_test_37() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = INK_MAX_VALUE / 2;
    process->trigger(-10);
    unit_test_assert("NPS UTC 1000_036 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_37", test_wait_refill_ink_value == 0);
}

//맥스값 체크
static void unit_test_38() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = INK_MAX_VALUE / 2;
    process->trigger(INK_MAX_VALUE);
    unit_test_assert("NPS UTC 1000_037 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_38", test_wait_refill_ink_value == 0);
}

//오버값 체크
static void unit_test_39() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = INK_MAX_VALUE / 2;
    process->trigger(5000);
    unit_test_assert("NPS UTC 1000_038 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_39", test_wait_refill_ink_value == 0);
}


//기본값 체크
static void unit_test_40() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);

    test_wait_refill_ink_value = INK_MAX_VALUE / 2;
    process->trigger(10);
    unit_test_assert("NPS UTC 1000_039 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_40", test_wait_refill_ink_value == 0);
}


//41 ~ 45 : ink_value = INK_MAX_VALUE, wait_refill_ink_value = INK_MAX_VALUE
//0 체크
static void unit_test_41() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);
    
    test_wait_refill_ink_value = INK_MAX_VALUE;
    process->trigger(0);
    unit_test_assert("NPS UTC 1000_040 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_41", test_wait_refill_ink_value == 0);
}

//음수 체크
static void unit_test_42() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);
    
    test_wait_refill_ink_value = INK_MAX_VALUE;
    process->trigger(-10);
    unit_test_assert("NPS UTC 1000_041 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_42", test_wait_refill_ink_value == 0);
}

//맥스값 체크
static void unit_test_43() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);
    
    test_wait_refill_ink_value = INK_MAX_VALUE;
    process->trigger(INK_MAX_VALUE);
    unit_test_assert("NPS UTC 1000_042 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_43", test_wait_refill_ink_value == 0);
}

//오버값 체크
static void unit_test_44() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);
    
    test_wait_refill_ink_value = INK_MAX_VALUE;
    process->trigger(5000);
    unit_test_assert("NPS UTC 1000_043 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_44", test_wait_refill_ink_value == 0);
}

//기본값 체크
static void unit_test_45() {
    struct WaitRefillInkAdditionProcess *process = get_process(WAIT_REFILL_INK_ADDITION_PROCESS);
    
    test_wait_refill_ink_value = INK_MAX_VALUE;
    process->trigger(10);
    unit_test_assert("NPS UTC 1000_044 WAIT_REFILL_INK_ADDITION_PROCESS - unit_test_45", test_wait_refill_ink_value == 0);
}
