#include <stdio.h>
#include "../../../../process.h"
#include "../../../../unittest.h"
#include "process.h"
#include "test.h"
#include "../../../../databases/ink_paper_state_database/process.h"


static int test_ink_value = 0;
static int test_wait_refill_ink_value = 0;
static int test_paper_value = 0;
static int test_wait_refill_paper_value = 0;

static struct InkPaperStateDatabase test_ink_paper_state_database = {
    .current_ink_value = &test_ink_value,
    .wait_refill_ink_value = &test_wait_refill_ink_value,
    .current_paper_value = &test_paper_value,
    .wait_refill_paper_value = &test_wait_refill_paper_value
};

static void unit_test_1();
static void unit_test_2();
static void unit_test_3();
static void unit_test_4();
static void unit_test_5();
static void unit_test_6();
static void unit_test_7();
static void unit_test_8();
static void unit_test_9();
static void unit_test_10();
static void unit_test_11();
static void unit_test_12();
static void unit_test_13();
static void unit_test_14();
static void unit_test_15();
static void unit_test_16();
static void unit_test_17();
static void unit_test_18();
static void unit_test_19();
static void unit_test_20();
static void unit_test_21();
static void unit_test_22();
static void unit_test_23();
static void unit_test_24();
static void unit_test_25();
static void unit_test_26();
static void unit_test_27();
static void unit_test_28();
static void unit_test_29();
static void unit_test_30();
static void unit_test_31();
static void unit_test_32();
static void unit_test_33();
static void unit_test_34();
static void unit_test_35();
static void unit_test_36();
static void unit_test_37();
static void unit_test_38();
static void unit_test_39();
static void unit_test_40();
static void unit_test_41();
static void unit_test_42();
static void unit_test_43();
static void unit_test_44();
static void unit_test_45();


void wait_refill_paper_addition_process_unit_test() {
    // 의존성 있는 프로세스 정의 (프로세스에서 호출하는 것들)
    set_process(INK_PAPER_STATE_DATABASE, &test_ink_paper_state_database);
    
    
    // 테스트
    test_paper_value = 0;
    unit_test_1();
    unit_test_2();
    unit_test_3();
    unit_test_4();
    unit_test_5();
    unit_test_6();
    unit_test_7();
    unit_test_8();
    unit_test_9();
    unit_test_10();
    unit_test_11();
    unit_test_12();
    unit_test_13();
    unit_test_14();
    unit_test_15();
    
    test_paper_value = PAPER_MAX_VALUE / 2;
    unit_test_16();
    unit_test_17();
    unit_test_18();
    unit_test_19();
    unit_test_20();
    unit_test_21();
    unit_test_22();
    unit_test_23();
    unit_test_24();
    unit_test_25();
    unit_test_26();
    unit_test_27();
    unit_test_28();
    unit_test_29();
    unit_test_30();
    
    
    test_paper_value = PAPER_MAX_VALUE;
    unit_test_31();
    unit_test_32();
    unit_test_33();
    unit_test_34();
    unit_test_35();
    unit_test_36();
    unit_test_37();
    unit_test_38();
    unit_test_39();
    unit_test_40();
    unit_test_41();
    unit_test_42();
    unit_test_43();
    unit_test_44();
    unit_test_45();
    
}


// 1~5 : paper_value = 0, wait_refill_paper_value = 0
//0 체크
static void unit_test_1() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = 0;
    process->trigger(0);
    unit_test_assert("NPS UTC 1000_045 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_1", test_wait_refill_paper_value == 0);
}

//음수 체크
static void unit_test_2() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = 0;
    process->trigger(-10);
    unit_test_assert("NPS UTC 1000_046 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_2", test_wait_refill_paper_value == 0);
}

//맥스값 체크
static void unit_test_3() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = 0;
    process->trigger(PAPER_MAX_VALUE);
    unit_test_assert("NPS UTC 1000_047 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_3", test_wait_refill_paper_value == PAPER_MAX_VALUE);
}

//오버값 체크
static void unit_test_4() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = 0;
    process->trigger(5000);
    unit_test_assert("NPS UTC 1000_048 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_4", test_wait_refill_paper_value == (PAPER_MAX_VALUE - test_paper_value));
}


//기본값 체크
static void unit_test_5() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = 0;
    process->trigger(10);
    unit_test_assert("NPS UTC 1000_049 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_5", test_wait_refill_paper_value == 10);
}



//6~10 : paper_value = 0, wait_refill_paper_value = PAPER_MAX_VALUE / 2
//0 체크
static void unit_test_6() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = PAPER_MAX_VALUE / 2;
    process->trigger(0);
    unit_test_assert("NPS UTC 1000_050 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_6", test_wait_refill_paper_value == PAPER_MAX_VALUE / 2 );
}

//음수 체크
static void unit_test_7() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = PAPER_MAX_VALUE / 2;
    process->trigger(-10);
    unit_test_assert("NPS UTC 1000_051 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_7", test_wait_refill_paper_value == PAPER_MAX_VALUE / 2 );
}

//맥스값 체크
static void unit_test_8() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = PAPER_MAX_VALUE / 2;
    process->trigger(PAPER_MAX_VALUE);
    unit_test_assert("NPS UTC 1000_052 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_8", test_wait_refill_paper_value == PAPER_MAX_VALUE);
}

//오버값 체크
static void unit_test_9() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = PAPER_MAX_VALUE / 2;
    process->trigger(5000);
    unit_test_assert("NPS UTC 1000_053 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_9", test_wait_refill_paper_value == (PAPER_MAX_VALUE - test_paper_value));
}


//기본값 체크
static void unit_test_10() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = PAPER_MAX_VALUE / 2;
    process->trigger(10);
    unit_test_assert("NPS UTC 1000_054 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_10", test_wait_refill_paper_value == (PAPER_MAX_VALUE / 2 + 10));
}


//11 ~ 15 : paper_value = 0, wait_refill_paper_value = PAPER_MAX_VALUE
//0 체크
static void unit_test_11() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);
    
    test_wait_refill_paper_value = PAPER_MAX_VALUE;
    process->trigger(0);
    unit_test_assert("NPS UTC 1000_055 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_11", test_wait_refill_paper_value == PAPER_MAX_VALUE);
}

//음수 체크
static void unit_test_12() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);
    
    test_wait_refill_paper_value = PAPER_MAX_VALUE;
    process->trigger(-10);
    unit_test_assert("NPS UTC 1000_056 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_12", test_wait_refill_paper_value == PAPER_MAX_VALUE);
}

//맥스값 체크
static void unit_test_13() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);
    
    test_wait_refill_paper_value = PAPER_MAX_VALUE;
    process->trigger(PAPER_MAX_VALUE);
    unit_test_assert("NPS UTC 1000_057 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_13", test_wait_refill_paper_value == PAPER_MAX_VALUE);
}

//오버값 체크
static void unit_test_14() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);
    
    test_wait_refill_paper_value = PAPER_MAX_VALUE;
    process->trigger(5000);
    unit_test_assert("NPS UTC 1000_058 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_14", test_wait_refill_paper_value == PAPER_MAX_VALUE);
}

//기본값 체크
static void unit_test_15() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);
    
    test_wait_refill_paper_value = PAPER_MAX_VALUE;
    process->trigger(10);
    unit_test_assert("NPS UTC 1000_059 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_15", test_wait_refill_paper_value == PAPER_MAX_VALUE);
}

// 16~20 : paper_value = PAPER_MAX_VALUE / 2, wait_refill_paper_value = 0
//0 체크
static void unit_test_16() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = 0;
    process->trigger(0);
    unit_test_assert("NPS UTC 1000_060 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_16", test_wait_refill_paper_value == 0);
}

//음수 체크
static void unit_test_17() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = 0;
    process->trigger(-10);
    unit_test_assert("NPS UTC 1000_061 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_17", test_wait_refill_paper_value == 0);
}

//맥스값 체크
static void unit_test_18() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = 0;
    process->trigger(PAPER_MAX_VALUE);
    unit_test_assert("NPS UTC 1000_062 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_18", test_wait_refill_paper_value == (PAPER_MAX_VALUE - test_paper_value));
}

//오버값 체크
static void unit_test_19() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = 0;
    process->trigger(5000);
    unit_test_assert("NPS UTC 1000_063 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_19", test_wait_refill_paper_value == (PAPER_MAX_VALUE - test_paper_value));
}


//기본값 체크
static void unit_test_20() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = 0;
    process->trigger(10);
    unit_test_assert("NPS UTC 1000_064 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_20", test_wait_refill_paper_value == 10);
}



//21~25 : paper_value = PAPER_MAX_VALUE / 2, wait_refill_paper_value = PAPER_MAX_VALUE / 2
//0 체크
static void unit_test_21() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = PAPER_MAX_VALUE / 2;
    process->trigger(0);
    unit_test_assert("NPS UTC 1000_065 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_21", test_wait_refill_paper_value == PAPER_MAX_VALUE / 2);
}

//음수 체크
static void unit_test_22() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = PAPER_MAX_VALUE / 2;
    process->trigger(-10);
    unit_test_assert("NPS UTC 1000_066 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_22", test_wait_refill_paper_value == PAPER_MAX_VALUE / 2);
}

//맥스값 체크
static void unit_test_23() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = PAPER_MAX_VALUE / 2;
    process->trigger(PAPER_MAX_VALUE);
    unit_test_assert("NPS UTC 1000_067 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_23", test_wait_refill_paper_value == (PAPER_MAX_VALUE - test_paper_value));
}

//오버값 체크
static void unit_test_24() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = PAPER_MAX_VALUE / 2;
    process->trigger(5000);
    unit_test_assert("NPS UTC 1000_068 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_24", test_wait_refill_paper_value == (PAPER_MAX_VALUE - test_paper_value));
}


//기본값 체크
static void unit_test_25() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = PAPER_MAX_VALUE / 2;
    process->trigger(10);
    unit_test_assert("NPS UTC 1000_069 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_25", test_wait_refill_paper_value == (PAPER_MAX_VALUE - test_paper_value));
}


//26 ~ 30 : paper_value = PAPER_MAX_VALUE / 2, wait_refill_paper_value = PAPER_MAX_VALUE
//0 체크
static void unit_test_26() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);
    
    test_wait_refill_paper_value = PAPER_MAX_VALUE;
    process->trigger(0);
    unit_test_assert("NPS UTC 1000_070 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_26",  test_wait_refill_paper_value == (PAPER_MAX_VALUE - test_paper_value));
}

//음수 체크
static void unit_test_27() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);
    
    test_wait_refill_paper_value = PAPER_MAX_VALUE;
    process->trigger(-10);
    unit_test_assert("NPS UTC 1000_071 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_27",  test_wait_refill_paper_value == (PAPER_MAX_VALUE - test_paper_value));
}

//맥스값 체크
static void unit_test_28() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);
    
    test_wait_refill_paper_value = PAPER_MAX_VALUE;
    process->trigger(PAPER_MAX_VALUE);
    unit_test_assert("NPS UTC 1000_072 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_28",  test_wait_refill_paper_value == (PAPER_MAX_VALUE - test_paper_value));
}

//오버값 체크
static void unit_test_29() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);
    
    test_wait_refill_paper_value = PAPER_MAX_VALUE;
    process->trigger(5000);
    unit_test_assert("NPS UTC 1000_073 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_29",  test_wait_refill_paper_value == (PAPER_MAX_VALUE - test_paper_value));
}

//기본값 체크
static void unit_test_30() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);
    
    test_wait_refill_paper_value = PAPER_MAX_VALUE;
    process->trigger(10);
    unit_test_assert("NPS UTC 1000_074 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_30",  test_wait_refill_paper_value == (PAPER_MAX_VALUE - test_paper_value));
}



// 31~35 : paper_value = PAPER_MAX_VALUE, wait_refill_paper_value = 0
//0 체크
static void unit_test_31() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = 0;
    process->trigger(0);
    unit_test_assert("NPS UTC 1000_075 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_31", test_wait_refill_paper_value == 0);
}

//음수 체크
static void unit_test_32() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = 0;
    process->trigger(-10);
    unit_test_assert("NPS UTC 1000_076 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_32", test_wait_refill_paper_value == 0);
}

//맥스값 체크
static void unit_test_33() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = 0;
    process->trigger(PAPER_MAX_VALUE);
    unit_test_assert("NPS UTC 1000_077 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_33", test_wait_refill_paper_value == 0);
}

//오버값 체크
static void unit_test_34() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = 0;
    process->trigger(5000);
    unit_test_assert("NPS UTC 1000_078 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_34", test_wait_refill_paper_value == 0);
}


//기본값 체크
static void unit_test_35() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = 0;
    process->trigger(10);
    unit_test_assert("NPS UTC 1000_079 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_35", test_wait_refill_paper_value == 0);
}



//36~40 : paper_value = PAPER_MAX_VALUE, wait_refill_paper_value = PAPER_MAX_VALUE / 2
//0 체크
static void unit_test_36() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = PAPER_MAX_VALUE / 2;
    process->trigger(0);
    unit_test_assert("NPS UTC 1000_080 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_36", test_wait_refill_paper_value == 0);
}

//음수 체크
static void unit_test_37() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = PAPER_MAX_VALUE / 2;
    process->trigger(-10);
    unit_test_assert("NPS UTC 1000_081 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_37", test_wait_refill_paper_value == 0);
}

//맥스값 체크
static void unit_test_38() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = PAPER_MAX_VALUE / 2;
    process->trigger(PAPER_MAX_VALUE);
    unit_test_assert("NPS UTC 1000_082 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_38", test_wait_refill_paper_value == 0);
}

//오버값 체크
static void unit_test_39() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = PAPER_MAX_VALUE / 2;
    process->trigger(5000);
    unit_test_assert("NPS UTC 1000_083 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_39", test_wait_refill_paper_value == 0);
}


//기본값 체크
static void unit_test_40() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);

    test_wait_refill_paper_value = PAPER_MAX_VALUE / 2;
    process->trigger(10);
    unit_test_assert("NPS UTC 1000_084 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_40", test_wait_refill_paper_value == 0);
}


//41 ~ 45 : paper_value = PAPER_MAX_VALUE, wait_refill_paper_value = PAPER_MAX_VALUE
//0 체크
static void unit_test_41() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);
    
    test_wait_refill_paper_value = PAPER_MAX_VALUE;
    process->trigger(0);
    unit_test_assert("NPS UTC 1000_085 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_41", test_wait_refill_paper_value == 0);
}

//음수 체크
static void unit_test_42() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);
    
    test_wait_refill_paper_value = PAPER_MAX_VALUE;
    process->trigger(-10);
    unit_test_assert("NPS UTC 1000_086 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_42", test_wait_refill_paper_value == 0);
}

//맥스값 체크
static void unit_test_43() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);
    
    test_wait_refill_paper_value = PAPER_MAX_VALUE;
    process->trigger(PAPER_MAX_VALUE);
    unit_test_assert("NPS UTC 1000_087 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_43", test_wait_refill_paper_value == 0);
}

//오버값 체크
static void unit_test_44() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);
    
    test_wait_refill_paper_value = PAPER_MAX_VALUE;
    process->trigger(5000);
    unit_test_assert("NPS UTC 1000_088 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_44", test_wait_refill_paper_value == 0);
}

//기본값 체크
static void unit_test_45() {
    struct WaitRefillPaperAdditionProcess *process = get_process(WAIT_REFILL_PAPER_ADDITION_PROCESS);
    
    test_wait_refill_paper_value = PAPER_MAX_VALUE;
    process->trigger(10);
    unit_test_assert("NPS UTC 1000_089 WAIT_REFILL_PAPER_ADDITION_PROCESS - unit_test_45", test_wait_refill_paper_value == 0);
}
