#include <stdio.h>
#include "../../../process.h"
#include "../../../unittest.h"
#include "process.h"
#include "test.h"
#include "../../../databases/ink_paper_state_database/process.h"

static int test_ink_value = 150;
static int test_wait_refill_ink_value = 0;
static int test_paper_value = 10;
static int test_wait_refill_paper_value = 0;

static struct InkPaperStateDatabase test_ink_paper_state_database = {
    .current_ink_value = &test_ink_value,
    .wait_refill_ink_value = &test_wait_refill_ink_value,
    .current_paper_value = &test_paper_value,
    .wait_refill_paper_value = &test_wait_refill_paper_value
};

static void unit_test_1();
static void unit_test_2();
static void unit_test_3();

void decrease_amount_of_ink_paper_unit_test() {
    // 의존성 있는 프로세스 정의 (프로세스에서 호출하는 것들)
    set_process(INK_PAPER_STATE_DATABASE, &test_ink_paper_state_database);
    
    // 테스트
    unit_test_1();
    unit_test_2();
    unit_test_3();
}

// 일반적인 감소 상황에 대한 테스트를 진행해보자.
static void unit_test_1() {
    struct DecreaseAmountOfInkPaper *process = get_process(DECREASE_AMOUNT_OF_INK_PAPER);
    
    process->trigger(100);
    unit_test_assert("NPS UTC 5000_000 DECREASE_AMOUNT_OF_INK_PAPER - unit_test_1", (test_ink_value == 50));
}

// 만약 잉크와 종이 감소량이 현재 용량을 초과할때?
static void unit_test_2() {
    struct DecreaseAmountOfInkPaper *process = get_process(DECREASE_AMOUNT_OF_INK_PAPER);
    
    test_ink_value = 150;
    process->trigger(151);
    unit_test_assert("NPS UTC 5000_001 DECREASE_AMOUNT_OF_INK_PAPER - unit_test_2", (test_ink_value == 0));
}

// 일부러 이상한 값 (마이너스 값)을 집어넣어보자.
static void unit_test_3() {
    struct DecreaseAmountOfInkPaper *process = get_process(DECREASE_AMOUNT_OF_INK_PAPER);
    
    test_ink_value = 0;
    process->trigger(-1);
    unit_test_assert("NPS UTC 5000_002 DECREASE_AMOUNT_OF_INK_PAPER - unit_test_3", (test_ink_value == 0));
}