#include <string.h>
#include "../../../process.h"
#include "../../../unittest.h"
#include "process.h"
#include "test.h"
#include "../../../databases/user_database/process.h"
#include "../../../databases/job_queue/process.h"


static void trigger();

// 프로세스 정의
struct JobQueuePop job_queue_pop = {
    .trigger = trigger
};


void init_job_queue_pop() {
    printf("Initialization Job Queue Pop...\t\t");
    set_process(JOB_QUEUE_POP, &job_queue_pop);
	SET_UNIT_TEST(JOB_QUEUE_POP, job_queue_pop_unit_test);
	printf("\033[92m[OK]\033[0m\n");
}

static void trigger() {
    int i = 0;
    struct JobQueue *job_queue = get_process(JOB_QUEUE);
    
    if(job_queue->jobs_info[0].fd != -1) fclose(job_queue->jobs_info[0].fd);
    
    free(job_queue->jobs_info[0].buffer);

    for(i = 0; i < JOB_MAX_SIZE - 1; i++){
        job_queue->jobs_info[i] = job_queue->jobs_info[i+1];
    }
    
    job_queue->jobs_info[JOB_MAX_SIZE - 1].job_id = -1;
    job_queue->jobs_info[JOB_MAX_SIZE - 1].current_page = 0;
    job_queue->jobs_info[JOB_MAX_SIZE - 1].state = 0;
}
