#include <stdio.h>
#include "../../../process.h"
#include "../../../unittest.h"
#include "process.h"
#include "test.h"
#include "../../../databases/job_queue/process.h"

static struct JobInfo test_jobs_info[JOB_MAX_SIZE];

static struct JobQueue test_job_queue = {
    .jobs_info = test_jobs_info
};

static void unit_test_1();
static void unit_test_2();
static void unit_test_3();
static void unit_test_4();
static void unit_test_5();
static void unit_test_6();


void job_queue_pop_unit_test() {
    // 의존성 있는 프로세스 정의 (프로세스에서 호출하는 것들)
    set_process(JOB_QUEUE, &test_job_queue);
    
    // 테스트
    unit_test_1();
    unit_test_2();
    unit_test_3();
    unit_test_4();
    unit_test_5();
    unit_test_6();
}


//JobQueue에 데이터가 0개
static void unit_test_1() {
    int i, boolean;
    struct JobQueuePop *process = get_process(JOB_QUEUE_POP);
    
    for(i = 0; i < JOB_MAX_SIZE; i++){
        test_jobs_info[i].job_id = -1;
        test_jobs_info[i].fd = -1;
    }
    
    process->trigger();
    
    boolean = 1;
    for(i = 0; i < JOB_MAX_SIZE; i++){
        boolean = boolean && (test_jobs_info[i].job_id == -1);
    }
    unit_test_assert("NPS UTC 5000_003 JOB_QUEUE_POP - unit_test_1", boolean);
}


//JobQueue에 데이터가 1개
static void unit_test_2() {
    int i, boolean;
    struct JobQueuePop *process = get_process(JOB_QUEUE_POP);
    
    for(i = 0; i < 1; i++){
        test_jobs_info[i].job_id = i;
        test_jobs_info[i].fd = -1;
    }
    for(i = 1; i < JOB_MAX_SIZE; i++){
        test_jobs_info[i].job_id = -1;
        test_jobs_info[i].fd = -1;
    }
    
    process->trigger();
    
    boolean = 1;
    for(i = 0; i < JOB_MAX_SIZE; i++){
        boolean &= (test_jobs_info[i].job_id == -1);
    }
    unit_test_assert("NPS UTC 5000_004 JOB_QUEUE_POP - unit_test_2", boolean);
    
}

//JobQueue에 데이터가 2개
static void unit_test_3() {
    int i, boolean;
    struct JobQueuePop *process = get_process(JOB_QUEUE_POP);
    
    for(i = 0; i < 2; i++){
        test_jobs_info[i].job_id = i;
        test_jobs_info[i].fd = -1;
    }
    for(i = 2; i < JOB_MAX_SIZE; i++){
        test_jobs_info[i].job_id = -1;
        test_jobs_info[i].fd = -1;
    }
    
    
    process->trigger();
    
    boolean = 1;
    for(i = 0; i < 1; i++){
        boolean &= (test_jobs_info[i].job_id == i+1);
    }
    for(i = 1; i < JOB_MAX_SIZE; i++){
        boolean &= (test_jobs_info[i].job_id == -1);
    }
    unit_test_assert("NPS UTC 5000_005 JOB_QUEUE_POP - unit_test_3", boolean);
    
}

//JobQueue에 데이터가 3개
static void unit_test_4() {
    int i, boolean;
    struct JobQueuePop *process = get_process(JOB_QUEUE_POP);
    
    for(i = 0; i < 3; i++){
        test_jobs_info[i].job_id = i;
        test_jobs_info[i].fd = -1;
    }
    for(i = 3; i < JOB_MAX_SIZE; i++){
        test_jobs_info[i].job_id = -1;
        test_jobs_info[i].fd = -1;
    }
    
    
    process->trigger();
    
    boolean = 1;
    for(i = 0; i < 2; i++){
        boolean &= (test_jobs_info[i].job_id == i+1);
    }
    for(i = 2; i < JOB_MAX_SIZE; i++){
        boolean &= (test_jobs_info[i].job_id == -1);
    }
    unit_test_assert("NPS UTC 5000_006 JOB_QUEUE_POP - unit_test_4", boolean);
    
}

//JobQueue에 데이터가 4개
static void unit_test_5() {
    int i, boolean;
    struct JobQueuePop *process = get_process(JOB_QUEUE_POP);
    
    for(i = 0; i < 4; i++){
        test_jobs_info[i].job_id = i;
        test_jobs_info[i].fd = -1;
    }
    for(i = 4; i < JOB_MAX_SIZE; i++){
        test_jobs_info[i].job_id = -1;
        test_jobs_info[i].fd = -1;
    }
    
    
    
    process->trigger();
    
    boolean = 1;
    for(i = 0; i < 3; i++){
        boolean &= (test_jobs_info[i].job_id == i+1);
    }
    for(i = 3; i < JOB_MAX_SIZE; i++){
        boolean &= (test_jobs_info[i].job_id == -1);
    }
    
    unit_test_assert("NPS UTC 5000_007 JOB_QUEUE_POP - unit_test_5", boolean);
    
}

//JobQueue에 데이터가 5개
static void unit_test_6() {
    int i, boolean;
    struct JobQueuePop *process = get_process(JOB_QUEUE_POP);
    
    for(i = 0; i < 5; i++){
        test_jobs_info[i].job_id = i;
        test_jobs_info[i].fd = -1;
    }
    
    
    process->trigger();
    
    boolean = 1;
    for(i = 0; i < 4; i++){
        boolean &= (test_jobs_info[i].job_id == i+1);
    }
    for(i = 4; i < JOB_MAX_SIZE; i++){
        boolean &= (test_jobs_info[i].job_id == -1);
    }
    
    unit_test_assert("NPS UTC 5000_008 JOB_QUEUE_POP - unit_test_6", boolean);
    
}
