#include "process.h"
#include "test.h"
#include "../../../process.h"
#include "../../../system.h"
#include "../../../unittest.h"
#include "../send_status_process/process.h"

static void tick();
static void (*current_state)();

static struct ViewController view_controller = {
    .tick = tick
};

static int tick_count;
static void idle();
static void send();

void init_view_controller() {
    printf("Initialization View Controller...\t\t");
    set_process(VIEW_CONTROLLER, &view_controller);
    SET_UNIT_TEST(VIEW_CONTROLLER, view_controller_unit_test);
    add_tick_listener(tick);
    tick_count = 0;
    current_state = idle;
    printf("\033[92m[OK]\033[0m\n");
}

static void tick() {
    current_state();

}

static void idle() {
    if((++tick_count) % 10 == 0) { // 500ms 에 한번씩 트리거 발생
        current_state = send;
    }
}

static void send() {
    ((struct SendStatusProcess *)get_process(SEND_STATUS_PROCESS))->trigger();
    tick_count = 0;
    current_state = idle;
}

