#include <stdio.h>
#include "process.h"
#include "unittest.h"

void (*unit_test_func [EOF_PROCESS])() = { 0, };

int success_count = 0;
int fail_count = 0;

void run_unit_test() {
	save_processes();
	
	int i;
	for(i=0; i<EOF_PROCESS; i++) {
		if(!unit_test_func[i]) continue;
		
		load_processes(); // reset
		unit_test_func[i]();
	}
	
	printf("\n\nALL:%d SUCCESS:%d FAIL:%d\n", success_count+fail_count, success_count, fail_count);
}


void set_unit_test_process(int id, void(*func)()) {
	if (id < 0 || id >= EOF_PROCESS) return;
	unit_test_func[id] = func;
}

void unit_test_assert(char *name, int cond) {
	printf("[TEST] %s\t\t\t", name);
	if(cond) {
		success_count += 1;
		printf("\033[92m[SUCCESS]\033[0m\n");
	} else {
		fail_count += 1;
		printf("\033[91m[FAIL]\033[0m\n");
	}
}
