#include <stdio.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/socket.h>


int main(int argc, char *argv[]) {
    int sock;
    int value;
    char buffer[5];
    struct sockaddr_in server;
    
    if(argc < 3) {
        printf("%s [ink|paper] [value]\n", argv[0]);
        exit(1);
    }
    
    value = atoi(argv[2]);
    if(value < 1 || (strcmp(argv[1], "ink") && strcmp(argv[1], "paper"))) {
        printf("%s [ink|paper] [value]\n", argv[0]);
        exit(1);
    }
    
    bzero(&server, sizeof(server));
    server.sin_addr.s_addr = inet_addr("127.0.0.1");
    server.sin_family = AF_INET;
    server.sin_port = htons(6500);
    
    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) {
        printf("Socket Error!\n");
        exit(1);
    }
    
    buffer[0] = !strcmp(argv[1], "ink") ? 0 : 1;
    buffer[1] = (value >> 24) & 0xff;
    buffer[2] = (value >> 16) & 0xff;
    buffer[3] = (value >> 8) & 0xff;
    buffer[4] = value & 0xff;
    
    sendto(sock, buffer, 5, 0, (struct sockaddr *)&server, sizeof(server));
}
