{"changed":true,"filter":false,"title":"test.c","tooltip":"/src/processes/view_process/send_status_process/test.c","value":"#include <string.h>\n#include <stdlib.h>\n#include \"process.h\"\n#include \"test.h\"\n#include \"../../../process.h\"\n#include \"../../../system.h\"\n#include \"../../../unittest.h\"\n#include \"../../../databases/ink_paper_state_database/process.h\"\n#include \"../../../databases/job_queue/process.h\"\n\nstatic struct JobInfo test_jobs_info[JOB_MAX_SIZE];\nstatic struct JobQueue test_job_queue = {\n    .jobs_info = test_jobs_info    \n};\n\nstatic test_ink_value = 150;\nstatic test_paper_value = 10;\nstatic test_wait_refill_paper_value = 0;\nstatic test_wait_refill_ink_value = 0;\n\nstatic struct InkPaperStateDatabase test_ink_paper_state_database = {\n    .current_ink_value = &test_ink_value,\n    .current_paper_value = &test_paper_value,\n    .wait_refill_ink_value = &test_wait_refill_ink_value,\n    .wait_refill_paper_value = &test_wait_refill_paper_value\n};\n\nstatic void unit_test_1();\nstatic void unit_test_2();\nstatic void unit_test_3();\nstatic void unit_test_4();\nstatic void unit_test_5();\n\nvoid send_status_process_unit_test() {\n    int i;\n    // 의존 프로세스 로드\n    set_process(INK_PAPER_STATE_DATABASE, &test_ink_paper_state_database);\n    set_process(JOB_QUEUE, &test_job_queue);\n    \n    srand(time(NULL));\n    // Job Queue 초기화\n    for ( i = 0 ; i < JOB_MAX_SIZE ; i++ )\n    {\n        test_jobs_info[i].job_id = i+1;\n        memset(test_jobs_info[i].user_id, 0, 12);\n        sprintf(test_jobs_info[i].user_id, \"user%d\", i);\n        test_jobs_info[i].current_page = rand() % 6;\n        test_jobs_info[i].total_page = i+5;\n    }\n    \n    test_jobs_info[0].state = 0;\n    \n    unit_test_1();\n    \n    test_wait_refill_ink_value = 1;\n    \n    unit_test_2();\n    \n    test_wait_refill_ink_value = 0;\n    test_jobs_info[0].state = 1;\n    \n    unit_test_3();\n    \n    test_ink_value -= 10;\n    \n    unit_test_4();\n    \n    test_paper_value -= 5;\n    \n    unit_test_5();\n    \n}\n\n// current state 가 제대로 표시되는지 확인! (1, 2, 3)\nstatic void unit_test_1() {\n    char buf[1024];\n    \n    struct SendStatusProcess *process = get_process(SEND_STATUS_PROCESS);\n\n    process->_transform(buf, 1024);\n    unit_test_assert(\"NPS UTC 4000_000 SEND_STATUS_PROCESS - unit_test_1\", \n        (strstr(buf, \"\\nState: printing\\n\") != NULL)\n    );\n}\n\nstatic void unit_test_2() {\n    char buf[1024];\n    \n    struct SendStatusProcess *process = get_process(SEND_STATUS_PROCESS);\n    process->_transform(buf, 1024);\n    \n    unit_test_assert(\"NPS UTC 4000_001 SEND_STATUS_PROCESS - unit_test_2\", \n        (strstr(buf, \"\\nState: system wait(refill)\\n\") != NULL)\n    );\n}\n\nstatic void unit_test_3() {\n    char buf[1024];\n    \n    struct SendStatusProcess *process = get_process(SEND_STATUS_PROCESS);\n    \n    process->_transform(buf, 1024);\n    unit_test_assert(\"NPS UTC 4000_002 SEND_STATUS_PROCESS - unit_test_3\",\n        (strstr(buf, \"\\nState: removing\\n\") != NULL)\n    );\n}\n\n// 잉크와 종이 값이 제대로 변경되는가?\n// 잉크 값 조절\nstatic void unit_test_4() {\n    char buf[1024];\n    \n    struct SendStatusProcess *process = get_process(SEND_STATUS_PROCESS);\n    process->_transform(buf, 1024);\n    unit_test_assert(\"NPS UTC 4000_003 SEND_STATUS_PROCESS - unit_test_4\",\n        (strstr(buf, \"\\n[Ink]\\t\") != NULL) &&\n        (strstr(buf, \"140\") != NULL)\n    );\n}\n\n// 종이 값 조절\nstatic void unit_test_5() {\n    char buf[1024];\n    \n    struct SendStatusProcess *process = get_process(SEND_STATUS_PROCESS);\n    process->_transform(buf, 1024);\n    unit_test_assert(\"NPS UTC 4000_004 SEND_STATUS_PROCESS - unit_test_5\",\n        (strstr(buf, \"[Paper]\\n\") != NULL) &&\n        (strstr(buf, \"5\") != NULL)\n    );\n}","undoManager":{"mark":-2,"position":12,"stack":[[{"start":{"row":80,"column":22},"end":{"row":80,"column":39},"action":"insert","lines":["NPS UTC 4000_000 "],"id":1,"ignore":true}],[{"start":{"row":91,"column":22},"end":{"row":91,"column":39},"action":"insert","lines":["NPS UTC 4000_000 "],"id":2,"ignore":true}],[{"start":{"row":91,"column":37},"end":{"row":91,"column":38},"action":"remove","lines":["0"],"id":3,"ignore":true},{"start":{"row":91,"column":37},"end":{"row":91,"column":38},"action":"insert","lines":["1"]}],[{"start":{"row":102,"column":22},"end":{"row":102,"column":39},"action":"insert","lines":["NPS UTC 4000_000 "],"id":4,"ignore":true}],[{"start":{"row":102,"column":37},"end":{"row":102,"column":38},"action":"remove","lines":["0"],"id":5,"ignore":true}],[{"start":{"row":102,"column":37},"end":{"row":102,"column":38},"action":"insert","lines":["2"],"id":6,"ignore":true}],[{"start":{"row":114,"column":22},"end":{"row":114,"column":38},"action":"insert","lines":["NPS UTC 4000_000"],"id":7,"ignore":true}],[{"start":{"row":114,"column":38},"end":{"row":114,"column":39},"action":"insert","lines":[" "],"id":8,"ignore":true}],[{"start":{"row":114,"column":37},"end":{"row":114,"column":38},"action":"remove","lines":["0"],"id":9,"ignore":true}],[{"start":{"row":114,"column":37},"end":{"row":114,"column":38},"action":"insert","lines":["3"],"id":10,"ignore":true}],[{"start":{"row":126,"column":22},"end":{"row":126,"column":39},"action":"insert","lines":["NPS UTC 4000_000 "],"id":11,"ignore":true}],[{"start":{"row":126,"column":37},"end":{"row":126,"column":38},"action":"remove","lines":["0"],"id":12,"ignore":true}],[{"start":{"row":126,"column":37},"end":{"row":126,"column":38},"action":"insert","lines":["4"],"id":13,"ignore":true}]]},"ace":{"folds":[],"scrolltop":947,"scrollleft":0,"selection":{"start":{"row":130,"column":1},"end":{"row":130,"column":1},"isBackwards":false},"options":{"guessTabSize":true,"useWrapMode":false,"wrapToView":true},"firstLineState":{"row":66,"state":"start","mode":"ace/mode/c_cpp"}},"timestamp":1447766668000}